Index: setup.py
===================================================================
--- setup.py	(revision 7fb471d81b5d11daed3df86a4e8427e6a832cf7a)
+++ setup.py	(revision fa81e94af983227efded2314c2c544f98e2c56ba)
@@ -380,4 +380,10 @@
     "src", "sas", "qtgui", "Perspectives", "Fitting", "UI")
 packages.extend(["sas.qtgui.Perspectives.Fitting", "sas.qtgui.Perspectives.Fitting.UI"])
+
+package_dir["sas.qtgui.Perspectives.Inversion"] = os.path.join(
+    "src", "sas", "qtgui", "Perspectives", "Inversion")
+package_dir["sas.qtgui.Perspectives.Inversion.UI"] = os.path.join(
+    "src", "sas", "qtgui", "Perspectives", "Inversion", "UI")
+packages.extend(["sas.qtgui.Perspectives.Inversion", "sas.qtgui.Perspectives.Inversion.UI"])
 
 ## Plotting
Index: src/sas/qtgui/Perspectives/Inversion/DMaxExplorerWidget.py
===================================================================
--- src/sas/qtgui/Perspectives/Inversion/DMaxExplorerWidget.py	(revision fa81e94af983227efded2314c2c544f98e2c56ba)
+++ src/sas/qtgui/Perspectives/Inversion/DMaxExplorerWidget.py	(revision fa81e94af983227efded2314c2c544f98e2c56ba)
@@ -0,0 +1,163 @@
+# -*- coding: utf-8 -*-
+"""
+Dialog panel to explore the P(r) inversion results for a range
+of D_max value. User picks a number of points and a range of
+distances, then can toggle between inversion outputs and see
+their distribution as a function of D_max.
+"""
+
+# global
+import sys
+import os
+import logging
+import numpy as np
+from PyQt5 import QtCore
+from PyQt5 import QtGui
+from PyQt5 import QtWidgets
+
+from twisted.internet import threads
+
+# sas-global
+from sas.qtgui.Plotting.PlotterData import Data1D
+from sas.qtgui.Plotting.Plotter import PlotterWidget
+import sas.qtgui.Utilities.GuiUtils as GuiUtils
+
+# local
+from .UI.dmax import Ui_DmaxExplorer
+# from InvariantDetails import DetailsDialog
+# from InvariantUtils import WIDGETS
+
+logger = logging.getLogger(__name__)
+
+def enum(*sequential, **named):
+    enums = dict(list(zip(sequential, list(range(len(sequential))))), **named)
+    return type('Enum', (), enums)
+
+W = enum( 'NPTS',           #0
+          'DMIN',               #1
+          'DMAX',               #2
+          'VARIABLE',         #3
+)
+
+class DmaxWindow(QtWidgets.QDialog, Ui_DmaxExplorer):
+    # The controller which is responsible for managing signal slots connections
+    # for the gui and providing an interface to the data model.
+    name = "Dmax Explorer"  # For displaying in the combo box
+
+    def __init__(self, pr_state, nfunc, parent=None):
+        super(DmaxWindow, self).__init__()
+        self.setupUi(self)
+
+        self.setWindowTitle("Dâââ Explorer")
+
+        self.pr_state = pr_state
+        self.nfunc = nfunc
+        self.communicator = GuiUtils.Communicate()
+
+        self.plot = PlotterWidget(self, self)
+        self.hasPlot = None
+        self.verticalLayout.insertWidget(0, self.plot)
+
+        # Let's choose the Standard Item Model.
+        self.model = QtGui.QStandardItemModel(self)
+        self.mapper = None
+
+        # # Connect buttons to slots.
+        # # Needs to be done early so default values propagate properly.
+        self.setupSlots()
+
+        # Set up the model.
+        self.setupModel()
+
+        # # Set up the mapper
+        self.setupMapper()
+
+    def setupSlots(self):
+        self.closeButton.clicked.connect(self.close)
+
+        self.model.itemChanged.connect(self.modelChanged)
+
+    def setupModel(self):
+        self.model.setItem(W.NPTS, QtGui.QStandardItem(str(self.nfunc)))
+        self.model.setItem(W.DMIN,
+                           QtGui.QStandardItem(
+                               str(0.9*self.pr_state.d_max)))
+        self.model.setItem(W.DMAX,
+                           QtGui.QStandardItem(
+                               str(1.1*self.pr_state.d_max)))
+        self.model.setItem(W.VARIABLE,
+                           QtGui.QStandardItem( "ÏÂ²/dof"))
+
+    def setupMapper(self):
+        self.mapper = QtWidgets.QDataWidgetMapper(self)
+        self.mapper.setOrientation(QtCore.Qt.Vertical)
+        self.mapper.setModel(self.model)
+
+        self.mapper.addMapping(self.Npts, W.NPTS)
+        self.mapper.addMapping(self.minDist, W.DMIN)
+        self.mapper.addMapping(self.maxDist, W.DMAX)
+        self.mapper.addMapping(self.dependentVariable, W.VARIABLE)
+
+        self.mapper.toFirst()
+
+    def modelChanged(self, item):
+        if not self.mapper:
+            return
+
+        iq0 = []
+        rg = []
+        pos = []
+        pos_err = []
+        osc = []
+        bck = []
+        chi2 = []
+
+        xs = np.linspace(float(self.model.item(W.DMIN).text()),
+                         float(self.model.item(W.DMAX).text()),
+                         float(self.model.item(W.NPTS).text()))
+
+        original = self.pr_state.d_max
+        for x in xs:
+            self.pr_state.d_max = x
+            try:
+                out, cov = self.pr_state.invert(self.pr_state.nfunc)
+
+                iq0.append(self.pr_state.iq0(out))
+                rg.append(self.pr_state.rg(out))
+                pos.append(self.pr_state.get_positive(out))
+                pos_err.append(self.pr_state.get_pos_err(out, cov))
+                osc.append(self.pr_state.oscillations(out))
+                bck.append(self.pr_state.background)
+                chi2.append(self.pr_state.chi2)
+            except:
+                # This inversion failed, skip this D_max value
+                msg = "ExploreDialog: inversion failed "
+                msg += "for D_max=%s\n%s" % (str(x), sys.exc_info()[1])
+                print(msg)
+                # logger.error(msg)
+
+        #Return the invertor to its original state
+        self.pr_state.d_max = original
+        self.pr_state.invert(self.nfunc)
+
+        plotter = str(self.model.item(W.VARIABLE).text())
+        if plotter == "ÏÂ²/dof":
+            ys = chi2
+        elif plotter == "I(Q=0)":
+            ys = iq0
+        elif plotter == "Rg":
+            ys = rg
+        elif plotter == "Oscillation parameter":
+            ys = osc
+        elif plotter == "Background":
+            ys = bck
+        elif plotter == "Positive Fraction":
+            ys = pos
+        else:
+            ys = pos_err
+
+        data = Data1D(xs, ys)
+        if self.hasPlot:
+            self.plot.removePlot(None)
+        self.hasPlot = True
+        self.plot.plot(data=data, marker="-")
Index: src/sas/qtgui/Perspectives/Inversion/InversionLogic.py
===================================================================
--- src/sas/qtgui/Perspectives/Inversion/InversionLogic.py	(revision fa81e94af983227efded2314c2c544f98e2c56ba)
+++ src/sas/qtgui/Perspectives/Inversion/InversionLogic.py	(revision fa81e94af983227efded2314c2c544f98e2c56ba)
@@ -0,0 +1,286 @@
+import math
+import pylab
+import numpy as np
+
+from sas.qtgui.Plotting.PlotterData import Data1D
+
+PR_FIT_LABEL = r"$P_{fit}(r)$"
+PR_LOADED_LABEL = r"$P_{loaded}(r)$"
+IQ_DATA_LABEL = r"$I_{obs}(q)$"
+IQ_FIT_LABEL = r"$I_{fit}(q)$"
+IQ_SMEARED_LABEL = r"$I_{smeared}(q)$"
+GROUP_ID_IQ_DATA = r"$I_{obs}(q)$"
+GROUP_ID_PR_FIT = r"$P_{fit}(r)$"
+
+
+class InversionLogic(object):
+    """
+    All the data-related logic. This class deals exclusively with Data1D/2D
+    No QStandardModelIndex here.
+    """
+
+    # TODO: Add way to change this value
+    _pr_n_pts = 51
+
+    def __init__(self, data=None):
+        self._data = data
+        self.data_is_loaded = False
+        if data is not None:
+            self.data_is_loaded = True
+
+    @property
+    def data(self):
+        return self._data
+
+    @data.setter
+    def data(self, value):
+        """ data setter """
+        self._data = value
+        self.data_is_loaded = True
+
+    def isLoadedData(self):
+        """ accessor """
+        return self.data_is_loaded
+
+    def new1DPlot(self, out, pr, q=None):
+        """
+        Create a new 1D data instance based on fitting results
+        """
+
+        qtemp = pr.x
+        if q is not None:
+            qtemp = q
+
+        # Make a plot
+        maxq = max(qtemp)
+
+        minq = min(qtemp)
+
+        # Check for user min/max
+        if pr.q_min is not None and maxq >= pr.q_min >= minq:
+            minq = pr.q_min
+        if pr.q_max is not None and maxq >= pr.q_max >= minq:
+            maxq = pr.q_max
+
+        x = pylab.arange(minq, maxq, maxq / 301.0)
+        y = np.zeros(len(x))
+        err = np.zeros(len(x))
+        for i in range(len(x)):
+            value = pr.iq(out, x[i])
+            y[i] = value
+            try:
+                err[i] = math.sqrt(math.fabs(value))
+            except:
+                err[i] = 1.0
+                print(("Error getting error", value, x[i]))
+
+        new_plot = Data1D(x, y)
+        new_plot.name = IQ_FIT_LABEL
+        new_plot.xaxis("\\rm{Q}", 'A^{-1}')
+        new_plot.yaxis("\\rm{Intensity} ", "cm^{-1}")
+        title = "I(q)"
+        new_plot.title = title
+
+        # If we have a group ID, use it
+        if 'plot_group_id' in pr.info:
+            new_plot.group_id = pr.info["plot_group_id"]
+        new_plot.id = IQ_FIT_LABEL
+
+        # If we have used slit smearing, plot the smeared I(q) too
+        if pr.slit_width > 0 or pr.slit_height > 0:
+            x = pylab.arange(minq, maxq, maxq / 301.0)
+            y = np.zeros(len(x))
+            err = np.zeros(len(x))
+            for i in range(len(x)):
+                value = pr.iq_smeared(pr.out, x[i])
+                y[i] = value
+                try:
+                    err[i] = math.sqrt(math.fabs(value))
+                except:
+                    err[i] = 1.0
+                    print(("Error getting error", value, x[i]))
+
+            new_plot = Data1D(x, y)
+            new_plot.name = IQ_SMEARED_LABEL
+            new_plot.xaxis("\\rm{Q}", 'A^{-1}')
+            new_plot.yaxis("\\rm{Intensity} ", "cm^{-1}")
+            # If we have a group ID, use it
+            if 'plot_group_id' in pr.info:
+                new_plot.group_id = pr.info["plot_group_id"]
+            new_plot.id = IQ_SMEARED_LABEL
+            new_plot.title = title
+
+        return new_plot
+
+    def update1DPlot(self, plot, out, pr, q=None):
+        """
+        Create a new 1D data instance based on fitting results
+        """
+
+        qtemp = pr.x
+        if q is not None:
+            qtemp = q
+
+        # Make a plot
+        maxq = max(qtemp)
+
+        minq = min(qtemp)
+
+        # Check for user min/max
+        if pr.q_min is not None and maxq >= pr.q_min >= minq:
+            minq = pr.q_min
+        if pr.q_max is not None and maxq >= pr.q_max >= minq:
+            maxq = pr.q_max
+
+        x = pylab.arange(minq, maxq, maxq / 301.0)
+        y = np.zeros(len(x))
+        err = np.zeros(len(x))
+        for i in range(len(x)):
+            value = pr.iq(out, x[i])
+            y[i] = value
+            try:
+                err[i] = math.sqrt(math.fabs(value))
+            except:
+                err[i] = 1.0
+                print(("Error getting error", value, x[i]))
+
+        plot.x = x
+        plot.y = y
+
+        # If we have used slit smearing, plot the smeared I(q) too
+        if pr.slit_width > 0 or pr.slit_height > 0:
+            x = pylab.arange(minq, maxq, maxq / 301.0)
+            y = np.zeros(len(x))
+            err = np.zeros(len(x))
+            for i in range(len(x)):
+                value = pr.iq_smeared(pr.out, x[i])
+                y[i] = value
+                try:
+                    err[i] = math.sqrt(math.fabs(value))
+                except:
+                    err[i] = 1.0
+                    print(("Error getting error", value, x[i]))
+
+            plot.x = x
+            plot.y = y
+
+        return plot
+
+    def newPRPlot(self, out, pr, cov=None):
+        """
+        """
+        # Show P(r)
+        x = pylab.arange(0.0, pr.d_max, pr.d_max / self._pr_n_pts)
+
+        y = np.zeros(len(x))
+        dy = np.zeros(len(x))
+
+        total = 0.0
+        pmax = 0.0
+        cov2 = np.ascontiguousarray(cov)
+
+        for i in range(len(x)):
+            if cov2 is None:
+                value = pr.pr(out, x[i])
+            else:
+                (value, dy[i]) = pr.pr_err(out, cov2, x[i])
+            total += value * pr.d_max / len(x)
+
+            # keep track of the maximum P(r) value
+            if value > pmax:
+                pmax = value
+
+            y[i] = value
+
+        # if self._normalize_output == True:
+        #     y = y / total
+        #     dy = dy / total
+        # elif self._scale_output_unity == True:
+        #     y = y / pmax
+        #     dy = dy / pmax
+
+        if cov2 is None:
+            new_plot = Data1D(x, y)
+        else:
+            new_plot = Data1D(x, y, dy=dy)
+        new_plot.name = PR_FIT_LABEL
+        new_plot.xaxis("\\rm{r}", 'A')
+        new_plot.yaxis("\\rm{P(r)} ", "cm^{-3}")
+        new_plot.title = "P(r) fit"
+        new_plot.id = PR_FIT_LABEL
+        # Make sure that the plot is linear
+        new_plot.xtransform = "x"
+        new_plot.ytransform = "y"
+        new_plot.group_id = GROUP_ID_PR_FIT
+
+        return new_plot
+
+    def updatePRPlot(self, plot, out, pr, cov=None):
+        x = pylab.arange(0.0, pr.d_max, pr.d_max / self._pr_n_pts)
+
+        y = np.zeros(len(x))
+        dy = np.zeros(len(x))
+
+        total = 0.0
+        pmax = 0.0
+        cov2 = np.ascontiguousarray(cov)
+
+        for i in range(len(x)):
+            if cov2 is None:
+                value = pr.pr(out, x[i])
+            else:
+                (value, dy[i]) = pr.pr_err(out, cov2, x[i])
+            total += value * pr.d_max / len(x)
+
+            # keep track of the maximum P(r) value
+            if value > pmax:
+                pmax = value
+
+            y[i] = value
+
+        # if self._normalize_output == True:
+        #     y = y / total
+        #     dy = dy / total
+        # elif self._scale_output_unity == True:
+        #     y = y / pmax
+        #     dy = dy / pmax
+        plot.x = x
+        plot.y = y
+
+        if cov2 is not None:
+            plot.dy = dy
+
+        return plot
+
+    def computeDataRange(self):
+        """
+        Wrapper for calculating the data range based on local dataset
+        """
+        return self.computeRangeFromData(self.data)
+
+    def computeRangeFromData(self, data):
+        """
+        Compute the minimum and the maximum range of the data
+        return the npts contains in data
+        """
+        qmin, qmax = None, None
+        if isinstance(data, Data1D):
+            try:
+                qmin = min(data.x)
+                qmax = max(data.x)
+            except (ValueError, TypeError):
+                msg = "Unable to find min/max/length of \n data named %s" % \
+                            self.data.filename
+                raise ValueError(msg)
+
+        else:
+            qmin = 0
+            try:
+                x = max(np.fabs(data.xmin), np.fabs(data.xmax))
+                y = max(np.fabs(data.ymin), np.fabs(data.ymax))
+            except (ValueError, TypeError):
+                msg = "Unable to find min/max of \n data named %s" % \
+                            self.data.filename
+                raise ValueError(msg)
+            qmax = np.sqrt(x * x + y * y)
+        return qmin, qmax
